#ifndef FNT__STREAM_DRIVER_SOCKET_MAIN_H
#define FNT__STREAM_DRIVER_SOCKET_MAIN_H

/*** global variables defined in .c file *******************************/

/*** typedefs(not structures) and defined constants ********************/

/*** enums *************************************************************/

/*** structures declarations (and typedefs of structures)***************/
struct fnt_stream_struct;
struct fnt_mainloop_struct;
typedef struct
{
    GIOChannel *socket;

    gchar *remote_host;
    gint remote_port;

    GIOFunc callbackIo;

    gchar *in_buffer;
    gchar *out_buffer;

    gsize in_buffer_len;
    gsize out_buffer_len;

} __fnt_driver_data_t;

/*** declarations of public functions **********************************/

DLLIMPORT bool assignToMainloop (struct fnt_stream_struct *,
				 struct fnt_mainloop_struct *, GIOFunc);

/* accept.c : */
DLLIMPORT void fnt_stream_socket_acceptCallback (GIOChannel *, GIOCondition,
					  gpointer);

/* open.c : */
DLLIMPORT bool open_stream (struct fnt_stream_struct *, const char *);

/* close.c : */
DLLIMPORT bool close_stream (fnt_stream_t *);

/* read.c : */
DLLIMPORT bool read_stream (fnt_stream_t *, gchar *, gsize, gsize *);

/* write.c : */
DLLIMPORT bool write_stream (fnt_stream_t *, gchar *, gsize, gsize *);


#endif
